
				list		p=16f877a	; list directive to define processor
				#include	<p16f877a.inc>	; processor specific variable definitions
	
				__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _RC_OSC & _WRT_OFF & _LVP_ON & _CPD_OFF

;****************************************************************
;*																*
;*                       VARIABLE DEFINITIONS					*
;*																*
;****************************************************************
;
;******* example of using Uninitialized Data Section  *******
;
TEMP_VAR		UDATA		0x20	; explicit address specified is not required
Var0			RES			1
Var1			RES			1		 
Var2			RES			1
				
ABC				UDATA		 
Var3			RES			1
Var4			RES			1
Var5			RES			1

BANK1			UDATA		 
Var6			RES			1
Var7			RES			1
Var8			RES			1

BANK2			UDATA			 
Var9			RES			2
Var10			RES			2
Var11			RES			2	

;******* example of using Shared Uninitialized Data Section  ****
INT_VAR			UDATA_SHR	0x71   
w_temp			RES     	1		; variable used for context saving 
status_temp		RES     	1		; variable used for context saving
pclath_temp		RES			1		; variable used for context saving





;**********************************************************************
STARTUP			CODE	0x000		; processor reset vector
				nop								; nop required for icd
				movlw	high  start				; load upper byte of 'start' label
				movwf	PCLATH					; initialize PCLATH
				goto	start					; go to beginning of program


INT_VECTOR		CODE	0x004			; interrupt vector location
				movwf	w_temp					; save off current W register contents
				movf	STATUS,w				; move status register into W register
				movwf	status_temp				; save off contents of STATUS register
				movf	PCLATH,w				; move pclath register into w register
				movwf	pclath_temp				; save off contents of PCLATH register

; isr code can go here or be located as a call subroutine elsewhere

				movf	pclath_temp,w			; retrieve copy of PCLATH register
				movwf	PCLATH					; restore pre-isr PCLATH register contents
				movf	status_temp,w			; retrieve copy of STATUS register
				movwf	STATUS					; restore pre-isr STATUS register contents
				swapf	w_temp,f
				swapf	w_temp,w				; restore pre-isr W register contents
				retfie							; return from interrupt


MAIN			CODE
start

				nop								; code starts here (example)
				banksel	Var1		
				movlw	h'50'
				movwf	Var0
				movwf	Var1
				movwf	Var2
;
				banksel	Var3
				movlw	h'51'
				movwf	Var3
				movwf	Var4
				movwf	Var5
;
				banksel	Var6
				movlw	h'52'
				movwf	Var6
				movwf	Var7
				movwf	Var8
;
				banksel	Var9
				movlw	h'53'
				movwf	Var9
				movwf	Var10
				movwf	Var11
;
				movlw	h'AA'
				movwf	w_temp		
				movwf	status_temp		
				movwf  	pclath_temp	
;			
				goto	$
;
				END                       ; directive 'end of program'

