   				LIST 	P=16f877a
  				#INCLUDE <P16f877a.INC>  
;
 				GLOBAL	EEPROM_INIT, READ_EEPROM, WRITE_EEPROM
				GLOBAL	Data_EE_Addr, Data_EE_Data 
;
;- RAM LOCATIONS------
;
; Reserve RAM location for ICD
;
EEPROM_Var		UDATA
Data_EE_Addr	RES		1 
Data_EE_Data   	RES		1 

;
;------ INTERNAL EEPROM READ ------
;
PROG1			code
;
READ_EEPROM
				banksel	EEADR
				movf	Data_EE_Addr,W		; Load EEPROM Address into Pointer
				movwf	EEADR
;
;     			bcf     INTCON,GIE  
				banksel	EECON1
				bcf	EECON1,EEPGD
				bsf	EECON1,RD
;
				banksel	EEDATA
				movf	EEDATA,W
;       		bsf     INTCON,GIE  
;
				banksel	PORTA
				return
;	
;----INTERNAL EEPROM WRITE-----
;
WRITE_EEPROM
				banksel	EEADR		
				movf	Data_EE_Addr,W		; Load EEPROM Address & Data into Register
				movwf	EEADR
				movf	Data_EE_Data,W
				movwf	EEDATA
;		
				banksel	EECON1
				bcf	EECON1,EEPGD			; Selected Data EEPROM for Writing
				bsf	EECON1,WREN				; Enable write function

;				bcf	INTCON,GIE				; Disable Interrupt

				movlw	0x55				; Write Sequence control 
				movwf	EECON2	
				movlw	0xAA
				movwf	EECON2	
			
				bsf	EECON1,WR				; Start EEPROM write operation
;
;				bsf	INTCON,GIE				; Enable Interrupt (If used interrupt )
				bcf	EECON1,WREN				; Disable write EEPROM  
;
				btfsc	EECON1,WR			; Waiting for writing completed (4mS)
				goto	$-1					; During write period, must hold both EEADR & EEDATA until complete
;
				banksel	PORTA
				return		
;
;--------- INITIAL EEPROM -------
EEPROM_INIT    
        		BCF     PIR2,EEIF
				banksel	PIE2
          		BCF     PIE2,EEIE
				banksel	PORTA				; switch back to Bank0
;-------------------------------- 
           		END   
