;
				title       "MAIN.ASM" 	
;
				list        p=16f877a	 
				#include	<p16f877a.inc> 
;
				EXTERN		DELAY_1MS, HEX_BCD, DECODE
				EXTERN		RS_232, KEYBOARD

				EXTERN		EEPROM_INIT, READ_EEPROM, WRITE_EEPROM
				EXTERN		Data_EE_Addr, Data_EE_Data
;
				GLOBAL		Count, Count_ms

;
 				UDATA		0x20	
Count			RES			1
Count_ms		RES			1
	
;
INT_VAR			UDATA_SHR	0x71   
w_temp			RES     	1		; variable used for context saving 
status_temp		RES     	1		; variable used for context saving
pclath_temp		RES			1		; variable used for context saving

;
STARTUP			CODE                                                                   
				pagesel	_initial                                                                                                                  
          		call	_initial  
; 	
INT_VECTOR		CODE	0x004			; interrupt vector location
				movwf	w_temp					; save off current W register contents
				movf	STATUS,w				; move status register into W register
				movwf	status_temp				; save off contents of STATUS register
				movf	PCLATH,w				; move pclath register into w register
				movwf	pclath_temp				; save off contents of PCLATH register

; isr code can go here or be located as a call subroutine elsewhere

				movf	pclath_temp,w			; retrieve copy of PCLATH register
				movwf	PCLATH					; restore pre-isr PCLATH register contents
				movf	status_temp,w			; retrieve copy of STATUS register
				movwf	STATUS					; restore pre-isr STATUS register contents
				swapf	w_temp,f
				swapf	w_temp,w				; restore pre-isr W register contents
				retfie							; return from interrupt
;
;************************************************
;*												*
;*         Main Program Here					*
;*												*
;************************************************
;
MAIN			CODE 
_initial 		clrwdt 		
               	clrw                                                                       
       			movlw	b'00001111'  
;                                                           
				banksel	TRISA				; Select RAM bank1	                                                                000804   1303     BCF            0x3,0x6                                                                                         
          		movwf	TRISA	                                                                   
          		movlw	b'11110000'                                                             
           		movwf	TRISB                                                                    
        		banksel	Count              	; Select RAM bank0                                                   
 				movlw	h'aa'
				movwf	Count 

;*************************************************                                                                                       
_loop			
				pagesel	RS_232				; Select PAGE 0
;                                                                        
       			call	RS_232       		; Page 0                                                             
         		call	DECODE              ; Page 0                                                                                                                 
         		call	DELAY_1MS           ; Page 0                                             
        		call	KEYBOARD 			; Page 0
				pagesel	Test_EEPROM
				call	Test_EEPROM			; Page 1
;
        		pagesel _loop 				; Select PAGE 1                                                              000812   008a     MOVWF     0xa            			movwf	PCLATH                                                                   
          		goto	_loop

;*************************************************
;
;----   Test the WRITE EEPROM Routine ----
; 
Test_EEPROM
				call	EEPROM_INIT

				movlw	0x0
				movwf	Data_EE_Addr
				movlw	'0'					; Load a ASCII code "0" to W
				movwf	Data_EE_Data
EE_Write
				call	WRITE_EEPROM
				incf	Data_EE_Data,F		; 0x30+ N
				incf	Data_EE_Addr,F  	; Point to next EEPROM Address
				btfss	Data_EE_Addr,5		; Write 32 bytes ?
				goto	EE_Write
;
;----   Test the READ EEPROM Routine ----
;
				movlw	0x20				; Get back EEPROM data to RAM with start addr at 0x20
				movwf	FSR
;		
				movlw	0x0					; Point to EEPROM start address at 0x00
				movwf	Data_EE_Addr
EE_Read
				call	READ_EEPROM			; Read EEPROM data with curent address to W registre
				movwf	INDF				; move W --> RAM 
;
				incf	FSR,F
				incf	Data_EE_Addr,F  	; Point to next EEPROM Address
				btfss	Data_EE_Addr,6		; Read 32 bytes ?
				goto	EE_Read
;    
        		return    		
;
				end
